Index: XIOS3/trunk/src/buffer_client.cpp
===================================================================
--- XIOS3/trunk/src/buffer_client.cpp	(revision 2546)
+++ XIOS3/trunk/src/buffer_client.cpp	(revision 2547)
@@ -14,23 +14,31 @@
   size_t CClientBuffer::maxRequestSize = 0;
 
-  CClientBuffer::CClientBuffer(MPI_Comm interComm, int serverRank, StdSize bufferSize, StdSize estimatedMaxEventSize)
+  CClientBuffer::CClientBuffer(MPI_Comm interComm, int serverRank, StdSize bufferSize, bool hasWindows)
     : interComm(interComm)
     , clientRank_(0)
     , serverRank(serverRank)
     , bufferSize(bufferSize)
-    , estimatedMaxEventSize(estimatedMaxEventSize)
     , maxEventSize(0)
     , current(0)
     , count(0)
     , pending(false)
-    , hasWindows(false) 
-  {
-     /*
-      if (windows[0]==MPI_WIN_NULL && windows[1]==MPI_WIN_NULL) hasWindows=false ;
-      else hasWindows=true ;
-     */
-
-      MPI_Alloc_mem(bufferSize+headerSize_, MPI_INFO_NULL, &bufferHeader[0]) ;
-      MPI_Alloc_mem(bufferSize+headerSize_, MPI_INFO_NULL, &bufferHeader[1]) ;
+    , hasWindows_(hasWindows) 
+  {
+      if (hasWindows_)
+      { 
+        windows_.resize(2) ;
+        windows_[0] = new CWindowDynamic() ;
+        windows_[0]->allocateBuffer(bufferSize+headerSize_) ;
+        bufferHeader[0] = (char*) windows_[0]->getBufferAddress() ;
+        windows_[1] = new CWindowDynamic() ;
+        windows_[1]->allocateBuffer(bufferSize+headerSize_) ;
+        bufferHeader[1] = (char*) windows_[1]->getBufferAddress() ;
+      }
+      else
+      {
+        MPI_Alloc_mem(bufferSize+headerSize_, MPI_INFO_NULL, &bufferHeader[0]) ;
+        MPI_Alloc_mem(bufferSize+headerSize_, MPI_INFO_NULL, &bufferHeader[1]) ;
+      }
+
       buffer[0] = bufferHeader[0]+headerSize_ ;
       buffer[1] = bufferHeader[1]+headerSize_ ;
@@ -55,32 +63,7 @@
       winState[1]=false ;
 
-
-    if (hasWindows)
-    {  
-    
-      MPI_Aint buffSize=bufferSize+headerSize_ ;
-      MPI_Win_attach(windows_[0], bufferHeader[0], buffSize) ;
-      MPI_Win_attach(windows_[1], bufferHeader[1], buffSize) ;
-    
-      MPI_Group group ;
-      int groupSize,groupRank ;
-      MPI_Win_get_group(windows_[0], &group) ;
-      MPI_Group_size(group, &groupSize) ;
-      MPI_Group_rank(group, &groupRank) ;
-      if (groupRank!=clientRank_) ERROR("CClientBuffer::CClientBuffer",<< " ClientRank != groupRank "<<clientRank_<<" "<<groupRank);
-
-      MPI_Win_get_group(windows_[1], &group) ;
-      MPI_Group_size(group, &groupSize) ;
-      MPI_Group_rank(group, &groupRank) ;
-      if (groupRank!=clientRank_) ERROR("CClientBuffer::CClientBuffer",<< " ClientRank != groupRank "<<clientRank_<<" "<<groupRank);
-
-      MPI_Win_lock(MPI_LOCK_EXCLUSIVE, clientRank_, 0, windows_[0]) ;
-      MPI_Win_lock(MPI_LOCK_EXCLUSIVE, clientRank_, 0, windows_[1]) ;
-
-      MPI_Win_unlock(clientRank_, windows_[1]) ;
-      MPI_Win_unlock(clientRank_, windows_[0]) ;
-    } 
-    retBuffer = new CBufferOut(buffer[current], bufferSize);
-    info(10) << "CClientBuffer: allocated 2 x " << bufferSize << " bytes for server " << serverRank << endl;
+    
+      retBuffer = new CBufferOut(buffer[current], bufferSize);
+      info(10) << "CClientBuffer: allocated 2 x " << bufferSize << " bytes for server " << serverRank << endl;
   }
 
@@ -91,35 +74,28 @@
     return address ;
   }
-
-  void CClientBuffer::attachWindows(vector<MPI_Win>& windows)
+  
+  MPI_Aint CClientBuffer::getWinBufferAddress(int i)
+  {
+    return windows_[i]->getWinBufferAddress() ;
+  }
+
+  void CClientBuffer::attachWindows(MPI_Comm& winComm)
   {
     isAttachedWindows_=true ;
-    windows_=windows ;
-    if (windows_[0]==MPI_WIN_NULL && windows_[1]==MPI_WIN_NULL) hasWindows=false ;
-    else hasWindows=true ;
-
-    if (hasWindows)
+
+    if (hasWindows_)
     {  
       MPI_Aint buffSize=bufferSize+headerSize_ ;
-      MPI_Win_attach(windows_[0], bufferHeader[0], buffSize) ;
-      MPI_Win_attach(windows_[1], bufferHeader[1], buffSize) ;
-    
-      MPI_Group group ;
-      int groupSize,groupRank ;
-      MPI_Win_get_group(windows_[0], &group) ;
-      MPI_Group_size(group, &groupSize) ;
-      MPI_Group_rank(group, &groupRank) ;
-      if (groupRank!=clientRank_) ERROR("CClientBuffer::CClientBuffer",<< " ClientRank != groupRank "<<clientRank_<<" "<<groupRank);
-
-      MPI_Win_get_group(windows_[1], &group) ;
-      MPI_Group_size(group, &groupSize) ;
-      MPI_Group_rank(group, &groupRank) ;
-      if (groupRank!=clientRank_) ERROR("CClientBuffer::CClientBuffer",<< " ClientRank != groupRank "<<clientRank_<<" "<<groupRank);
-
-      MPI_Win_lock(MPI_LOCK_EXCLUSIVE, clientRank_, 0, windows_[0]) ;
-      MPI_Win_lock(MPI_LOCK_EXCLUSIVE, clientRank_, 0, windows_[1]) ;
-
-      MPI_Win_unlock(clientRank_, windows_[1]) ;
-      MPI_Win_unlock(clientRank_, windows_[0]) ;
+      windows_[0]->create(winComm) ;
+      windows_[0]->attach() ;
+      windows_[1]->create(winComm) ;
+      windows_[1]->attach() ;
+
+      windows_[0]->lockExclusive(clientRank_) ;
+      windows_[1]->lockExclusive(clientRank_) ;
+
+      windows_[0]->unlockExclusive(clientRank_) ;
+      windows_[1]->unlockExclusive(clientRank_) ;
+
     } 
 
@@ -129,13 +105,17 @@
   CClientBuffer::~CClientBuffer()
   {
-     //freeWindows() ;
-     if (hasWindows)
-     {
-       MPI_Win_detach(windows_[0],bufferHeader[0]);
-       MPI_Win_detach(windows_[1],bufferHeader[1]);
-       MPI_Free_mem(bufferHeader[0]) ;
-       MPI_Free_mem(bufferHeader[1]) ;
-     }
-     delete retBuffer;
+    if (hasWindows_)
+    {
+      windows_[0]->detach() ;
+      windows_[1]->detach() ;
+      delete windows_[0] ;
+      delete windows_[1] ;
+    }
+    else 
+    {
+      MPI_Free_mem(bufferHeader[0]) ;
+      MPI_Free_mem(bufferHeader[1]) ;
+    }
+    delete retBuffer;
   }
 
@@ -143,8 +123,9 @@
   {
     CTimer::get("lock buffer").resume();
-    if (hasWindows)
+    if (isAttachedWindows_)    
     {
       if (winState[current]==true) ERROR("CClientBuffer::lockBuffer(void)",<<"Try lo lock client buffer but winState said it is already locked") ;
-      MPI_Win_lock(MPI_LOCK_EXCLUSIVE,clientRank_, 0, windows_[current]) ;
+      //MPI_Win_lock(MPI_LOCK_EXCLUSIVE,clientRank_, 0, windows_[current]) ;
+      windows_[current]->lockExclusive(clientRank_) ;
       winState[current]=true ;
     }
@@ -155,8 +136,9 @@
   {
     CTimer::get("unlock buffer").resume();
-    if (hasWindows)
+    if (isAttachedWindows_)
     {
       if (winState[current]==false) ERROR("CClientBuffer::lockBuffer(void)",<<"Try lo unlock client buffer but winState said it is already unlocked") ;
-      MPI_Win_unlock(clientRank_, windows_[current]) ;
+      //MPI_Win_unlock(clientRank_, windows_[current]) ;
+      windows_[current]->unlockExclusive(clientRank_) ;
       winState[current]=false ;
     }
@@ -189,8 +171,4 @@
     {
       maxEventSize = size;
-
-      if (size > estimatedMaxEventSize)
-        error(0) << "WARNING: Unexpected event of size " << size << " for server " << serverRank
-                 << " (estimated max event size = " << estimatedMaxEventSize << ")" << std::endl;
 
       if (size > maxRequestSize) maxRequestSize = size;
@@ -319,15 +297,18 @@
   {
 
-    if (hasWindows)
+    bufferSize=newSize ;
+
+    if (hasWindows_)
     { 
-      MPI_Win_detach(windows_[0], bufferHeader[0]) ;
-      MPI_Win_detach(windows_[1], bufferHeader[1]) ;
-    }
-    MPI_Free_mem(bufferHeader[0]) ;
-    MPI_Free_mem(bufferHeader[1]) ;
-
-    bufferSize=newSize ;
-    MPI_Alloc_mem(bufferSize+headerSize_, MPI_INFO_NULL, &bufferHeader[0]) ;
-    MPI_Alloc_mem(bufferSize+headerSize_, MPI_INFO_NULL, &bufferHeader[1]) ;
+      windows_[0]->detach();
+      windows_[1]->detach();
+      
+      windows_[0]->attach(bufferSize+headerSize_) ;
+      bufferHeader[0] = (char*) windows_[0] -> getBufferAddress() ;
+      windows_[1]->attach(bufferSize+headerSize_) ;
+      bufferHeader[1] = (char*) windows_[1] -> getBufferAddress() ;
+    }
+    
+    
     buffer[0] = bufferHeader[0]+headerSize_ ;
     buffer[1] = bufferHeader[1]+headerSize_ ;
@@ -353,15 +334,12 @@
     current=0 ;
     
-    if (hasWindows)
+    if (hasWindows_)
     {  
-    
-      MPI_Win_attach(windows_[0], bufferHeader[0], bufferSize+headerSize_) ;
-      MPI_Win_attach(windows_[1], bufferHeader[1], bufferSize+headerSize_) ;
-          
-      MPI_Win_lock(MPI_LOCK_EXCLUSIVE, clientRank_, 0, windows_[0]) ;
-      MPI_Win_lock(MPI_LOCK_EXCLUSIVE, clientRank_, 0, windows_[1]) ;
-
-      MPI_Win_unlock(clientRank_, windows_[1]) ;
-      MPI_Win_unlock(clientRank_, windows_[0]) ;
+
+      windows_[0]->lockExclusive(clientRank_) ;
+      windows_[1]->lockExclusive(clientRank_) ;
+      
+      windows_[1]->unlockExclusive(clientRank_) ;
+      windows_[0]->unlockExclusive(clientRank_) ;
     } 
 
@@ -373,10 +351,11 @@
     bufOut->put(timelineEventChangeBufferSize);
     bufOut->put(newBufferSize_);
-    bufOut->put(this->getWinAddress(0));
-    bufOut->put(this->getWinAddress(1));
+    
+    bufOut->put(this->getWinBufferAddress(0));
+    bufOut->put(this->getWinBufferAddress(1));
 
     resizingBufferStep_=4;
     unlockBuffer() ;
-    info(100)<<"CClientBuffer::resizeBuffer(size_t newSize) : resizing buffer of server "<<serverRank<<" ; new size : "<<newSize<<" ; winAdress[0] "<<this->getWinAddress(0)<<" winAdress[1] "<<this->getWinAddress(1)<<endl;
+    info(100)<<"CClientBuffer::resizeBuffer(size_t newSize) : resizing buffer of server "<<serverRank<<" ; new size : "<<newSize<<" ; winAdress[0] "<<this->getWinBufferAddress(0)<<" winAdress[1] "<<this->getWinBufferAddress(1)<<endl;
   }
 
@@ -397,5 +376,5 @@
     lockBuffer() ;
     ret=*notify[current] == notifyResizeBuffer_ ? true : false ;
-    if (ret || !hasWindows) 
+    if (ret || !hasWindows_) 
     {
       *notify[current] = notifyNothing_ ;
Index: XIOS3/trunk/src/buffer_client.hpp
===================================================================
--- XIOS3/trunk/src/buffer_client.hpp	(revision 2546)
+++ XIOS3/trunk/src/buffer_client.hpp	(revision 2547)
@@ -7,4 +7,5 @@
 #include "mpi.hpp"
 #include "cxios.hpp"
+#include "window_dynamic.hpp"
 
 namespace xios
@@ -15,5 +16,5 @@
       static size_t maxRequestSize;
 
-      CClientBuffer(MPI_Comm intercomm, int serverRank, StdSize bufferSize, StdSize estimatedMaxEventSize);
+      CClientBuffer(MPI_Comm intercomm, int serverRank, StdSize bufferSize, bool hasWindows);
       ~CClientBuffer();
 //      void createWindows(MPI_Comm oneSidedComm) ;
@@ -28,4 +29,5 @@
       StdSize remain(void);
       MPI_Aint getWinAddress(int numWindows) ;
+      MPI_Aint getWinBufferAddress(int numWindows) ;
       void infoBuffer(void) ;
       bool isNotifiedFinalized(void) ;
@@ -33,5 +35,5 @@
       void fixBufferSize(size_t bufferSize) { newBufferSize_=bufferSize ; isGrowableBuffer_=false ; resizingBufferStep_=1 ;}
       void fixBuffer(void) { isGrowableBuffer_=false ;}
-      void attachWindows(vector<MPI_Win>& windows) ;
+      void attachWindows(MPI_Comm& winComm) ;
       bool isAttachedWindows(void) { return isAttachedWindows_ ;}
     private:
@@ -58,5 +60,4 @@
       StdSize maxEventSize;
       StdSize bufferSize;
-      const StdSize estimatedMaxEventSize;
       bool isFinalized_=false ;
 
@@ -69,6 +70,6 @@
       CBufferOut* retBuffer;
       const MPI_Comm interComm;
-      std::vector<MPI_Win> windows_ ;
-      bool hasWindows=false ;
+      std::vector<CWindowDynamic*> windows_ ;
+      bool hasWindows_=false ;
       bool isAttachedWindows_=false ;
       double latency_=0 ;
Index: XIOS3/trunk/src/buffer_server.cpp
===================================================================
--- XIOS3/trunk/src/buffer_server.cpp	(revision 2546)
+++ XIOS3/trunk/src/buffer_server.cpp	(revision 2547)
@@ -3,4 +3,5 @@
 #include "buffer_server.hpp"
 #include "timer.hpp"
+#include "window_dynamic.hpp"
 
 
@@ -8,5 +9,5 @@
 {
 
-  CServerBuffer::CServerBuffer(vector<MPI_Win>& windows, vector<MPI_Aint>& winAddress, int windowsRank, StdSize buffSize) 
+  CServerBuffer::CServerBuffer(vector<CWindowDynamic*>& windows, vector<MPI_Aint>& winAddress, int windowsRank, StdSize buffSize) 
   : hasWindows(true), windows_(windows), windowsRank_(windowsRank), winAddress_(winAddress)
   {
@@ -18,5 +19,5 @@
     MPI_Alloc_mem(size, MPI_INFO_NULL, &buffer) ;
     currentWindows=1 ;
-    if (windows[0]==MPI_WIN_NULL && windows[1]==MPI_WIN_NULL) hasWindows=false ;
+    if (windows[0]==nullptr && windows[1]==nullptr) hasWindows=false ;
   }
 
@@ -239,27 +240,23 @@
     bool ok=false ;
     
-    MPI_Group group ;
-    int groupSize,groupRank ;
-    MPI_Win_get_group(windows_[currentWindows], &group) ;
-    MPI_Group_size(group, &groupSize) ;
-    MPI_Group_rank(group, &groupRank) ;
-    
+   
     lockBuffer(); 
     CTimer::get("getBufferFromClient_locked").resume() ;   
 // lock is acquired
 
-    MPI_Get(&clientTimeline, 1, MPI_LONG_LONG_INT, windowsRank_ , MPI_Aint_add(winAddress_[currentWindows],timeLineOffset_*sizeof(size_t)), 1, MPI_LONG_LONG_INT,windows_[currentWindows]) ;
-    MPI_Get(&clientCount, 1, MPI_LONG_LONG_INT, windowsRank_ , MPI_Aint_add(winAddress_[currentWindows],countOffset_*sizeof(size_t)), 1, MPI_LONG_LONG_INT,windows_[currentWindows]) ;
-    MPI_Win_flush(windowsRank_, windows_[currentWindows]) ;
-
+    windows_[currentWindows]->get(&clientTimeline, 1, MPI_LONG_LONG_INT, windowsRank_ , MPI_Aint_add(winAddress_[currentWindows],timeLineOffset_*sizeof(size_t)), 1, MPI_LONG_LONG_INT) ;
+    windows_[currentWindows]->get(&clientCount, 1, MPI_LONG_LONG_INT, windowsRank_ , MPI_Aint_add(winAddress_[currentWindows],countOffset_*sizeof(size_t)), 1, MPI_LONG_LONG_INT) ;
+    windows_[currentWindows]->flush(windowsRank_) ;
+   
     if (timeLine==clientTimeline)
     {
       buffer=(char*)getBuffer(clientCount) ;
       count=clientCount ;
-      MPI_Get(buffer, clientCount, MPI_CHAR, windowsRank_, MPI_Aint_add(winAddress_[currentWindows],4*sizeof(size_t)) , clientCount, MPI_CHAR, windows_[currentWindows]) ;
+      windows_[currentWindows]->get(buffer, clientCount, MPI_CHAR, windowsRank_, MPI_Aint_add(winAddress_[currentWindows],4*sizeof(size_t)) , clientCount, MPI_CHAR) ;
+      
       clientTimeline = 0 ;
       clientCount = 0 ;
-      MPI_Put(&clientTimeline, 1, MPI_LONG_LONG_INT, windowsRank_ , MPI_Aint_add(winAddress_[currentWindows],timeLineOffset_*sizeof(size_t)), 1, MPI_LONG_LONG_INT,windows_[currentWindows]) ;
-      MPI_Put(&clientCount, 1, MPI_LONG_LONG_INT, windowsRank_ , MPI_Aint_add(winAddress_[currentWindows],countOffset_*sizeof(size_t)), 1, MPI_LONG_LONG_INT,windows_[currentWindows]) ;
+      windows_[currentWindows]->put(&clientTimeline, 1, MPI_LONG_LONG_INT, windowsRank_ , MPI_Aint_add(winAddress_[currentWindows],timeLineOffset_*sizeof(size_t)), 1, MPI_LONG_LONG_INT) ;
+      windows_[currentWindows]->put(&clientCount, 1, MPI_LONG_LONG_INT, windowsRank_ , MPI_Aint_add(winAddress_[currentWindows],countOffset_*sizeof(size_t)), 1, MPI_LONG_LONG_INT) ;
 
 // release lock
@@ -298,5 +295,6 @@
   {
     if (!hasWindows) return ;
-    MPI_Win_lock(MPI_LOCK_EXCLUSIVE,windowsRank_,0,windows_[currentWindows]) ;
+    //MPI_Win_lock(MPI_LOCK_EXCLUSIVE,windowsRank_,0,windows_[currentWindows]) ;
+    windows_[currentWindows]->lockExclusive(windowsRank_) ;
   }
 
@@ -304,5 +302,5 @@
   {
     if (!hasWindows) return ;
-    MPI_Win_unlock(windowsRank_,windows_[currentWindows]) ;
+    windows_[currentWindows]->unlockExclusive(windowsRank_) ;
   }
   
@@ -313,5 +311,5 @@
     lockBuffer(); 
 // lock is acquired
-    MPI_Put(&notify, 1, MPI_LONG_LONG_INT, windowsRank_ , MPI_Aint_add(winAddress_[currentWindows], notifyOffset_*sizeof(size_t)), 1, MPI_LONG_LONG_INT,windows_[currentWindows]) ;
+    windows_[currentWindows]->put(&notify, 1, MPI_LONG_LONG_INT, windowsRank_ , MPI_Aint_add(winAddress_[currentWindows], notifyOffset_*sizeof(size_t)), 1, MPI_LONG_LONG_INT) ;
     unlockBuffer() ;
   }
@@ -324,5 +322,5 @@
     lockBuffer(); 
 // lock is acquired
-    MPI_Put(&notify, 1, MPI_LONG_LONG_INT, windowsRank_ , MPI_Aint_add(winAddress_[currentWindows], notifyOffset_*sizeof(size_t)), 1, MPI_LONG_LONG_INT,windows_[currentWindows]) ;
+    windows_[currentWindows]->put(&notify, 1, MPI_LONG_LONG_INT, windowsRank_ , MPI_Aint_add(winAddress_[currentWindows], notifyOffset_*sizeof(size_t)), 1, MPI_LONG_LONG_INT) ;
     unlockBuffer() ;
   }
Index: XIOS3/trunk/src/buffer_server.hpp
===================================================================
--- XIOS3/trunk/src/buffer_server.hpp	(revision 2546)
+++ XIOS3/trunk/src/buffer_server.hpp	(revision 2547)
@@ -7,4 +7,6 @@
 #include "mpi.hpp"
 #include "cxios.hpp"
+#include "window_dynamic.hpp"
+
 
 namespace xios
@@ -13,5 +15,5 @@
   {
     public:
-      CServerBuffer(vector<MPI_Win>& windows, vector<MPI_Aint>& winAddress, int windowsRank, StdSize bufSize) ;
+      CServerBuffer(vector<CWindowDynamic*>& windows, vector<MPI_Aint>& winAddress, int windowsRank, StdSize bufSize) ;
       ~CServerBuffer() ;
 
@@ -37,5 +39,5 @@
       size_t size;
       size_t used ;  // count of element occupied
-      std::vector<MPI_Win> windows_ ;
+      std::vector<CWindowDynamic*> windows_ ;
       std::vector<MPI_Aint> winAddress_ ;
       bool resizingBuffer_ = false ;
Index: XIOS3/trunk/src/client.cpp
===================================================================
--- XIOS3/trunk/src/client.cpp	(revision 2546)
+++ XIOS3/trunk/src/client.cpp	(revision 2547)
@@ -180,6 +180,6 @@
       MPI_Comm_size(CXios::getXiosComm(), &xiosCommSize) ;
       MPI_Comm_size(clientsComm_, &clientsCommSize) ;
-      if (xiosCommSize==clientsCommSize) CXios::setUsingServer() ;
-      else CXios::setNotUsingServer() ;
+      if (xiosCommSize==clientsCommSize) CXios::setNotUsingServer() ;
+      else CXios::setUsingServer() ;
 
       /////////////////////////////////////////
Index: XIOS3/trunk/src/cxios.cpp
===================================================================
--- XIOS3/trunk/src/cxios.cpp	(revision 2546)
+++ XIOS3/trunk/src/cxios.cpp	(revision 2547)
@@ -313,5 +313,9 @@
   }
 
-  
+  void CXios::launchThreadManager(bool isXiosServer)
+  {
+    CThreadManager::initialize(isXiosServer) ;
+  }
+
   void CXios::finalizeRegistryManager()
   {
@@ -339,4 +343,9 @@
   }
   
+  void CXios::finalizeThreadManager()
+  {
+    CThreadManager::finalize()  ;
+  }
+
   void CXios::finalizeDaemonsManager()
   {
Index: XIOS3/trunk/src/cxios.hpp
===================================================================
--- XIOS3/trunk/src/cxios.hpp	(revision 2546)
+++ XIOS3/trunk/src/cxios.hpp	(revision 2547)
@@ -11,4 +11,5 @@
 #include "coupler_manager.hpp"
 #include "registry_manager.hpp"
+#include "thread_manager.hpp"
 #include "mpi_garbage_collector.hpp"
 
@@ -106,4 +107,5 @@
      static void launchCouplerManager(bool isXiosServer) ;
      static void launchRegistryManager(bool isXiosServer) ;
+     static void launchThreadManager(bool isXiosServer) ;
     
      static void finalizeServicesManager() ;
@@ -113,4 +115,5 @@
      static void finalizeCouplerManager() ;
      static void finalizeRegistryManager() ;
+     static void finalizeThreadManager() ;
 
      static CRegistryManager*   getRegistryManager(void) { return registryManager_ ;}
Index: XIOS3/trunk/src/manager/daemons_manager.cpp
===================================================================
--- XIOS3/trunk/src/manager/daemons_manager.cpp	(revision 2546)
+++ XIOS3/trunk/src/manager/daemons_manager.cpp	(revision 2547)
@@ -24,4 +24,5 @@
     CXios::launchContextsManager(isXiosServer) ;
     CXios::launchCouplerManager(isXiosServer) ;
+    CXios::launchThreadManager(isXiosServer) ;
  
     if (isXiosServer) CServer::launchServersRessource(splitComm) ;
@@ -41,13 +42,15 @@
     CXios::getServicesManager()->eventLoop() ;
     CXios::getContextsManager()->eventLoop() ;
-    if (isServer_) {
-        if (CServer::isRoot) {
-            CServer::listenOasisEnddef() ;
-            CServer::listenRootOasisEnddef() ;
-        }
-        else {
-            CServer::listenRootOasisEnddef() ;
-        }
-        return CServer::getServersRessource()->eventLoop(false) ;
+    if (isServer_) 
+    {
+      if (CServer::isRoot) 
+      {
+        CServer::listenOasisEnddef() ;
+        CServer::listenRootOasisEnddef() ;
+      }
+      else CServer::listenRootOasisEnddef() ;
+      
+      if (CThreadManager::isUsingThreads()) return CServer::getServersRessource()->isFinished() ;
+      else return CServer::getServersRessource()->eventLoop(false) ;
     }
     else  return CXios::getPoolRessource()->eventLoop(false) ;
@@ -76,4 +79,5 @@
       CXios::finalizeRessourcesManager() ;
       CXios::finalizeRegistryManager() ;
+      CXios::finalizeThreadManager() ;
       isFinalized_=true ;
     }
Index: XIOS3/trunk/src/manager/pool_ressource.cpp
===================================================================
--- XIOS3/trunk/src/manager/pool_ressource.cpp	(revision 2546)
+++ XIOS3/trunk/src/manager/pool_ressource.cpp	(revision 2547)
@@ -8,4 +8,5 @@
 #include "timer.hpp"
 #include "event_scheduler.hpp"
+#include "thread_manager.hpp"
 
 namespace xios
@@ -33,4 +34,21 @@
     else eventScheduler_= make_shared<CEventScheduler>(poolComm) ;
     freeRessourceEventScheduler_ = eventScheduler_ ;
+    std::hash<string> hashString ;
+    hashId_ = hashString("CPoolRessource::"+Id) ;
+    if (CThreadManager::isUsingThreads()) CThreadManager::spawnThread(&CPoolRessource::threadEventLoop, this) ;
+  }
+
+  void CPoolRessource::synchronize(void)
+  {
+    bool out=false ; 
+    size_t timeLine=0 ;
+          
+    eventScheduler_->registerEvent(timeLine, hashId_) ;
+    while (!out)
+    {
+      CThreadManager::yield() ;
+      out = eventScheduler_->queryEvent(timeLine,hashId_) ;
+      if (out) eventScheduler_->popEvent() ;
+    }
   }
 
@@ -122,6 +140,14 @@
     MPI_Comm_rank(poolComm_, &commRank) ;
     winNotify_->popFromExclusiveWindow(commRank, this, &CPoolRessource::notificationsDumpIn) ;
-    if (notifyType_==NOTIFY_CREATE_SERVICE) createService() ;
-    else if (notifyType_==NOTIFY_CREATE_SERVICE_ONTO) createServiceOnto() ;
+    if (notifyType_==NOTIFY_CREATE_SERVICE) 
+    {
+      if (CThreadManager::isUsingThreads()) synchronize() ;
+      createService() ;
+    }
+    else if (notifyType_==NOTIFY_CREATE_SERVICE_ONTO) 
+    {
+      if (CThreadManager::isUsingThreads()) synchronize() ;
+      createServiceOnto() ;
+    }
   }
 
@@ -233,7 +259,49 @@
     }
     CTimer::get("CPoolRessource::eventLoop").suspend();
-    if (services_.empty() && finalizeSignal_) return true ;
-    else return false ;
-  }
+    if (services_.empty() && finalizeSignal_) finished_=true ;
+    return finished_ ;
+  }
+
+  void CPoolRessource::threadEventLoop(void)
+  {
+    CTimer::get("CPoolRessource::eventLoop").resume();
+    info(100)<<"Launch Thread for  CPoolRessource::threadEventLoop, pool id = "<<Id_<<endl ;
+    CThreadManager::threadInitialize() ; 
+    
+    do
+    {
+
+      double time=MPI_Wtime() ;
+      int flag ;
+      MPI_Iprobe(MPI_ANY_SOURCE, MPI_ANY_TAG, MPI_COMM_WORLD, &flag, MPI_STATUS_IGNORE);
+      if (time-lastEventLoop_ > eventLoopLatency_) 
+      {
+        //checkCreateServiceNotification() ;
+        checkNotifications() ;
+        lastEventLoop_=time ;
+      }
+    
+      for(auto it=services_.begin();it!=services_.end();++it) 
+      {
+        if (it->second->isFinished())
+        {
+          delete it->second ; 
+          services_.erase(it) ;
+          // destroy server_context -> to do later
+          break ;
+        } ;
+      }
+
+      CTimer::get("CPoolRessource::eventLoop").suspend();
+      if (services_.empty() && finalizeSignal_) finished_=true ;
+      
+      if (!finished_) CThreadManager::yield() ;
+    
+    } while (!finished_) ;
+
+    CThreadManager::threadFinalize() ;
+    info(100)<<"Close thread for  CPoolRessource::threadEventLoop, pool id = "<<Id_<<endl ;
+  }
+
 /*
   void CPoolRessource::checkCreateServiceNotification(void)
@@ -347,5 +415,5 @@
   }
 
-  void CPoolRessource::createService(MPI_Comm serviceComm, shared_ptr<CEventScheduler> eventScheduler, const std::string& serviceId, int partitionId, int type, int nbPartitions) // for clients & attached
+  void CPoolRessource::createService(MPI_Comm serviceComm, shared_ptr<CEventScheduler> eventScheduler, const std::string& serviceId, int partitionId, int type, int nbPartitions) // for clients
   {
     services_[std::make_tuple(serviceId,partitionId)] = new CService(serviceComm, eventScheduler, Id_, serviceId, partitionId, type, nbPartitions) ;
Index: XIOS3/trunk/src/manager/pool_ressource.hpp
===================================================================
--- XIOS3/trunk/src/manager/pool_ressource.hpp	(revision 2546)
+++ XIOS3/trunk/src/manager/pool_ressource.hpp	(revision 2547)
@@ -35,4 +35,5 @@
     void createServiceOnto(const std::string& serviceId, int type, const std::string& OnServiceId) ;
     bool eventLoop(bool serviceOnly=false) ;
+    void threadEventLoop(void) ;
     bool hasService(const std::string serviceId, int partitionId) {return services_.count(make_tuple(serviceId,partitionId))>0 ;}
     CService* getService(const std::string serviceId, int partitionId) { return services_[make_tuple(serviceId,partitionId)]; }
@@ -50,4 +51,5 @@
     void createService(void) ;
     void createServiceOnto(void) ;
+    void synchronize(void) ;
     
 //    void createServiceNotify(int rank, const std::string& serviceId, int type, int size, int nbPartitions, bool in) ;
@@ -58,6 +60,11 @@
   public:
     void createNewServiceOnto(const std::string& serviceId, int type, const string& onServiceId) ;
-    
-    private:
+  
+  private:
+    bool finished_=false ;
+  public:
+    bool isFinished(void) { return finished_ ;}
+
+  private:
     MPI_Comm poolComm_ ;
     
@@ -74,9 +81,10 @@
     std::string Id_ ;
     bool finalizeSignal_ ;
-    
+        
     const double eventLoopLatency_=0; 
     double lastEventLoop_=0. ;
 
     private:
+      size_t hashId_ ;
       shared_ptr<CEventScheduler> eventScheduler_ ;
       shared_ptr<CEventScheduler> freeRessourceEventScheduler_ ;
Index: XIOS3/trunk/src/manager/server_context.cpp
===================================================================
--- XIOS3/trunk/src/manager/server_context.cpp	(revision 2546)
+++ XIOS3/trunk/src/manager/server_context.cpp	(revision 2547)
@@ -6,4 +6,5 @@
 #include "register_context_info.hpp"
 #include "services.hpp"
+#include "thread_manager.hpp"
 #include "timer.hpp"
 
@@ -50,4 +51,6 @@
     info(10)<<"Context "<< CXios::getContextsManager()->getServerContextName(poolId, serviceId, partitionId, type, contextId)<<" created, on local rank "<<localRank
                         <<" and global rank "<<globalRank<<endl  ;
+   
+    if (CThreadManager::isUsingThreads()) CThreadManager::spawnThread(&CServerContext::threadEventLoop, this) ;
   }
 
@@ -84,15 +87,18 @@
     }
     
-    MPI_Request req ;
-    MPI_Status status ;
-    MPI_Ibarrier(intraComm,&req) ;
-    
-    int flag=false ;
-    while(!flag) 
-    {
-      CXios::getDaemonsManager()->servicesEventLoop() ;
-      MPI_Test(&req,&flag,&status) ;
-    }
-
+    if (wait)
+    {
+      MPI_Request req ;
+      MPI_Status status ;
+      MPI_Ibarrier(intraComm,&req) ;
+    
+      int flag=false ;
+      while(!flag) 
+      {
+        CXios::getDaemonsManager()->servicesEventLoop() ;
+        MPI_Test(&req,&flag,&status) ;
+      }
+    }
+    
     MPI_Bcast(&ok, 1, MPI_INT, 0, intraComm) ;
 
@@ -117,16 +123,6 @@
       MPI_Comm_size(contextComm_,&commSize ) ;
 */
-      if (nOverlap> 0 )
-      {
-        while (get<0>(overlapedComm_[name_])==false) CXios::getDaemonsManager()->servicesEventLoop() ;
-        isAttachedMode_=true ;
-        cout<<"CServerContext::createIntercomm : total overlap ==> context in attached mode"<<endl ;
-        interCommClient=newInterCommClient ;
-        interCommServer=newInterCommServer ;
-      }
-      else if (nOverlap==0)
+      if (nOverlap==0)
       { 
-        cout<<"CServerContext::createIntercomm : No overlap ==> context in server mode"<<endl ;
-        isAttachedMode_=false ;
         MPI_Intercomm_create(intraComm, 0, xiosComm_, contextLeader, 3141, &interCommClient) ;
         MPI_Comm_dup(interCommClient, &interCommServer) ;
@@ -136,5 +132,5 @@
       else
       {
-        cout<<"CServerContext::createIntercomm : partial overlap ==> not managed"<<endl ;
+        ERROR("void CServerContext::createIntercomm(void)",<<"CServerContext::createIntercomm : overlap ==> not managed") ;
       }
     }
@@ -259,4 +255,39 @@
   }
 
+  void CServerContext::threadEventLoop(void)
+  {
+    
+    info(100)<<"Launch Thread for CServerContext::threadEventLoop, context id = "<<context_->getId()<<endl ;
+    CThreadManager::threadInitialize() ; 
+    do
+    {
+      CTimer::get("CServerContext::eventLoop").resume();
+      int flag ;
+      MPI_Iprobe(MPI_ANY_SOURCE, MPI_ANY_TAG, MPI_COMM_WORLD, &flag, MPI_STATUS_IGNORE);
+
+      if (winNotify_!=nullptr) checkNotifications() ;
+
+
+      if (context_!=nullptr)  
+      {
+        if (context_->eventLoop())
+        {
+          info(100)<<"Remove context server with id "<<context_->getId()<<endl ;
+          CContext::removeContext(context_->getId()) ;
+          context_=nullptr ;
+          // destroy context ??? --> later
+        }
+      }
+      CTimer::get("CServerContext::eventLoop").suspend();
+      if (context_==nullptr && finalizeSignal_) finished_=true ;
+ 
+      if (!finished_) CThreadManager::yield() ;
+    }
+    while (!finished_) ;
+    
+    CThreadManager::threadFinalize() ;
+    info(100)<<"Close thread for CServerContext::threadEventLoop"<<endl ;
+  }
+
   void CServerContext::createIntercomm(void)
   {
@@ -280,18 +311,7 @@
      MPI_Comm_size(contextComm_,&commSize ) ;
 
-    if (nOverlap==commSize)
-    {
-      info(10)<<"CServerContext::createIntercomm : total overlap ==> context in attached mode"<<endl ;
-      isAttachedMode_=true ;
-      interCommClient=get<2>(it->second) ;
-      interCommServer=get<1>(it->second) ;
-      context_ -> createClientInterComm(interCommClient, interCommServer ) ;
-      clientsInterComm_.push_back(interCommClient) ;
-      clientsInterComm_.push_back(interCommServer) ;
-    }
-    else if (nOverlap==0)
+    if (nOverlap==0)
     { 
       info(10)<<"CServerContext::createIntercomm : No overlap ==> context in server mode"<<endl ;
-      isAttachedMode_=false ;
       MPI_Intercomm_create(contextComm_, 0, xiosComm_, remoteLeader, 3141, &interCommServer) ;
       MPI_Comm_dup(interCommServer,&interCommClient) ;
@@ -302,5 +322,5 @@
     else
     {
-      ERROR("void CServerContext::createIntercomm(void)",<<"CServerContext::createIntercomm : partial overlap ==> not managed") ;
+      ERROR("void CServerContext::createIntercomm(void)",<<"CServerContext::createIntercomm : overlap ==> not managed") ;
     }
    
Index: XIOS3/trunk/src/manager/server_context.hpp
===================================================================
--- XIOS3/trunk/src/manager/server_context.hpp	(revision 2546)
+++ XIOS3/trunk/src/manager/server_context.hpp	(revision 2547)
@@ -29,11 +29,15 @@
 
     bool eventLoop(bool serviceOnly=false) ;
+    void threadEventLoop(void) ;
     void notificationsDumpOut(CBufferOut& buffer) ;
     void notificationsDumpIn(CBufferIn& buffer) ;
     void finalizeSignal(void) ;
     void freeComm(void) ;
-    bool isAttachedMode(void) { return isAttachedMode_ ;}
     CService* getParentService(void) {return parentService_ ; }
-
+    
+    private : 
+      bool finished_=false ;
+    public:
+      bool isFinished(void) { return finished_ ; }
     private:
     void createIntercomm(void) ;
@@ -60,5 +64,4 @@
     bool finalizeSignal_ ;
     bool hasNotification_ ;
-    bool isAttachedMode_ ;
 
     const double eventLoopLatency_=0; 
